// CEC SANYO CD PLAYER FIRMWARE
// ARDUINO IDE whith MIGHTY CORE addon.
// ВАЖНО - в инструментах установить NO BOOTLOADER
// вживление ДУ. первая версия от 10.04.2021
// остался один глюк, когда редко, при установке диска, сразу включается PLAY и не работают кнопки навигации по трекам.
// пульт ДУ запрограммирован частично
// нет антизависатора
// нет режима TEST
// вход в отладочный режим - при включении питания удерживать STOP+PLAY
//    /Dxx573k/ 2020-2021 RYAZAN
//Прошивка для ATMEGA32
//CLOCK 10240kHz.
//Распиновка:
// SIGNAL     PIN   PORT    OUT                 OUT     PORT      PIN     SIGNAL

// LASER ON    0     PB0    1   OUT         OUT 40      PA0     24    DISP DATA D0
// RW          1     PB1    2   OUT         OUT 39      PA1     24    DISP DATA D1
// WQ          2     PB2    3   IN          OUT 38      PA2     24    DISP DATA D2
// DISP RS     3     PB3    4   OUT         OUT 37      PA3     24    DISP DATA D3
// DISP E      4     PB4    5   OUT         OUT 36      PA4     24    DISP DATA D4
// DIN/MOSI    5     PB5    6   OUT         OUT 35      PA5     24    DISP DATA D5
// DOUT/MISO   6     PB6    7   IN          OUT 34      PA6     24    DISP DATA D6
// SCK         7     PB7    8   OUT         OUT 33      PA7     31    DISP DATA D7 
//                   RESET  9                   32      VREF
//                   VDD    10                  31      G
//                   G      11                  30      VDD
//                   X      12              IN  29      PC7     23    KEY PLAY
//                   X      13              IN  28      PC6     22    KEY STOP
// OPEN        8     PD0    14  OUT         IN  27      PC5     21    KEY >>
// CLOSE       9     PD1    15  OUT         IN  26      PC4     20    KEY <<
// NC/RESET    10    PD2    16  OUT         IN  25      PC3     19    KEY NEXT
// R/C IN      11    PD3    17  IN          IN  24      PC2     18    KEY PREV
// NC/SMUTE    12    PD4    18  OUT         IN  23      PC1     17    KEY EJECT
// PU IN       13    PD5    19  IN          IN  22      PC0     16    DOOR O/C
// O/C SW      14    PD6    20  IN          IN  21      PD7     15    NC/OVERLOAD

// Перечень процедур:
// void Stop_Mode_player()                                                //выносим все, что не относится к проигрыванию музыки
// void TOC_read_proc()                                                   //процедура чтения таблицы TOC сюда приходим только если TOC_READ_OK==0;
// void clear_screen()                                                    //Процедура очистки экрана
// void print_error()                                                     //Процедура печати ошибки
// void print_no_disk()                                                   //Процедура печати нет диска
// void print_play(byte data_out2)                                        //процедура печати значка режима стоп-пауза-плей
// void print_progressbar(byte data_offset)                               //печать любой палки прогресс бара. смещения 44, 32, 21, 11, 0
// void print_digit_x1 (byte digit_x1)                                    //печать единиц номера трека
// void print_digit_x10 (byte digit_x10)                                  //печать десятков номера трека 
// void print_time (byte data_out2, byte data_offset, byte line_bottom)   //печать цифр времени. Смещение 43, 32 (минуты), 11, 0 (секунды)
// void print_clock_divide (byte line_bottom)                             //печать разделителя. line_bottom = 1 рисуем календарь, =0 ничего не рисуем.
// void write_data(byte data_w)                                           //Процедура записи данных в экран. Работет быстро
// void write_command(byte command_w)                                     //Процедура записи команды в экран. Работет быстро
// void keyboard(){                                                       //key_hold отражает текущую нажатую или ненажатую клавишу. Дверь лотка всегда независима от остальных кнопок.
// void Command_Init(){                                                   //INIT YM7121C
// void Command_Write(byte address                                        //Подпрограмма выдачи однобайтовых комманд на серву.
// void Command_Search(byte address, byte S_min, byte S_sec, byte s_frame)//Подпрограмма выдачи команды SEARCH на серву.
// byte Command_Read(byte status_read)                                    //Подпрограмма читает Q-CODE с сервы.
// void ACC_RW_Write()                                                    //Подтверждение получения статуса. отдельная процедура нужна для инициализации и финализации чтения статусов и Q-кодов.
// void Clear_TOC_table()                                                 //подпрограмма очистки переменных при смене диска.
// void print_prog3()                                                     //Подпрограмма печати на экране
// void print_prog()                                                      //Процедура отладочной печати на экране.

#include <SPI.h>// inslude the SPI library:
#include <avr/pgmspace.h>
// раздел переменных
// экран, графика
#define LCD_SETGRAPHICMODE 0x1f   //ЭТО ОШМЕТКИ ОТ LIQUIDCRYSTAL
#define LCD_FUNCTIONSET 0x20      //ЭТО ОШМЕТКИ ОТ LIQUIDCRYSTAL
#define LCD_ENTRYMODESET 0x04     //ЭТО ОШМЕТКИ ОТ LIQUIDCRYSTAL
#define LCD_SETCGRAMADDR 0x40     //ЭТО ОШМЕТКИ ОТ LIQUIDCRYSTAL
#define LCD_SETDDRAMADDR 0x80     //ЭТО ОШМЕТКИ ОТ LIQUIDCRYSTAL
const byte rs_pin = 3, en_pin = 4;//, d0=24, d1=25, d2=26, d3=27, d4 = 28, d5 = 29, d6 = 30, d7 = 31;
byte data_out=0;                // вспомогательная переменная для загрузки данных в дисплей
byte display_mode=0;            //данные для инициализации формируются тут. 0 - обычный режим, 1 - отключение экрана, 128 - инженерный режим
byte screen[10]={7,101,101,101,101,101,101,101,0,53}; //содержимое текущего экрана экрана
                                //screen[0] = 0 PLAY, =1 STOP, =2 PAUSE, =3 NODISK, =4 ERROR, =5 TEST, =6 TOC READ
                                //screen[1] = TRACK NUM
                                //screen[2] = TRACK NUM
                                //screen[3] = MIN
                                //screen[4] = MIN
                                //screen[5] = CLOCK DIVIDE
                                //screen[6] = SEC
                                //screen[7] = SEC
                                //screen[8] = факт печати за цикл.
                                //screen[9] = calendar_screen
const byte play_sprite[4][20]={
                    {128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255},// STOP
                    {128, 128, 0, 0, 0, 0, 0, 0, 0, 0, 255, 255, 127, 127, 62, 62, 28, 28, 8, 8},                    //PLAY
                    {128, 128, 128, 0, 0, 0, 128, 128, 128, 0, 255, 255, 255, 0, 0, 0, 255, 255, 255, 0},           //PAUSE
                    {128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 9, 25, 57, 121, 249, 249, 121, 57, 25, 9}};   //NO DISK (EJECT)
                    
const byte clock_divide[2][10]={// разделитель минут и секунд.
                    {0,0,0,0,192,192,0,0,0,0},
                    {0,0,0,0,48,48,0,0,0,0}};
const byte digit_sprite[10][24]={
                      {252,254,255,3,1,1,1,1,3,255,254,252,        63,127,255,192,128,128,128,128,192,255,127,63},   //0 is OK
                      {0,0,1,1,255,255,255,1,1,0,0,0,              0,0,0,0,255,127,63,24,8,0,0,0},                  //1 is not OK
                      {1,1,129,129,129,129,129,129,193,255,127,63, 62,127,255,193,128,128,128,128,128,192,192,64},   //2 is OK
                      {124,254,255,131,1,1,1,1,1,3,3,2,            60,126,255,195,129,129,129,128,128,192,192,64},   //3 is OK
                      {255,255,255,64,64,64,64,64,64,192,192,192,  255,255,255,192,224,112,56,28,14,7,3,1},          //4 is OK 
                      {124,254,255,131,1,1,1,1,1,3,3,2,            128,128,129,129,129,129,129,129,129,255,255,255}, //5 is OK                      
                      {124,254,255,131,1,1,1,1,131,255,254,252,    0,128,129,129,129,129,129,193,225,127,63,31},     //6 is OK
                      {0,0,0,128,255,255,127,0,0,0,0,0,            252,254,255,131,129,128,128,128,128,128,128,128}, //7 is OK
                      {124,254,255,131,1,1,1,1,131,255,254,124,    60,126,255,195,129,129,129,129,195,255,126,60},   //8 is OK
                      {248,252,254,135,131,129,129,129,129,129,1,0,63,127,255,193,128,128,128,128,193,255,127,62}};  //9 is OK
// ТОНКИЙ ШРИФТ
const byte clock_sprite[10][22]={
                          {0,192,224,48,16,16,16,48,224,192,0,    0,63,127,192,128,128,128,192,127,63,0},   //0 is OK
                          {0,0,0,16,240,240,16,0,0,0,0,           0,0,0,0,255,127,32,0,0,0,0},              //1 is OK
                          {0,16,16,16,16,16,16,16,240,240,0,      0,56,124,198,130,130,130,195,97,32,0}, 
                          {0,192,224,48,16,16,16,48,96,64,0,      0,49,123,206,132,132,128,192,96,32,0},
                          {0,240,240,0,0,0,0,0,0,0,0,             0,255,255,193,97,49,25,13,7,3,0},
                          {0,192,224,48,16,16,16,48,96,64,0,      0,129,131,134,132,132,132,132,252,252,0},
                          {0,192,224,48,16,16,16,48,224,192,0,    0,3,135,140,136,136,200,100,63,31,0},
                          {0,0,0,0,240,240,0,0,0,0,0,             0,240,248,141,135,131,130,128,128,128,0},
                          {0,192,224,48,16,16,16,48,224,192,0,    0,49,123,206,132,132,132,206,123,49,0},
                          {0,128,192,96,48,16,16,16,16,0,0,       0,63,127,194,129,129,129,195,126,60,0}};

const byte no_disk_sprite[2][100]={//печатается как угодно первый адрес - номер строки, второй адрес - номер столбца. Все перевернуто.
                      {255,255,8,8,8,8,8,8,255,255,0,0,7,143,216,112,32,32,32,32,
                      255,255,0,0,132,134,3,1,1,1,1,3,254,252,0,0,255,255,192,96,
                      48,24,12,6,255,255,0,0,252,254,3,1,1,1,1,3,254,252,0,0,
                      0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,0,0,224,241,
                      17,17,17,17,17,19,254,252,0,0,255,255,128,128,128,128,128,128,255,255},
                      {0,1,3,2,2,2,2,3,1,0,0,0,3,3,0,0,0,0,0,0,
                      3,3,0,0,0,1,3,2,2,2,2,3,1,0,0,0,3,3,0,0,
                      0,0,0,0,3,3,0,0,31,63,98,66,66,66,66,99,49,16,0,0,
                      0,0,0,0,0,0,2,2,2,2,3,3,2,2,2,2,0,0,0,1,
                      3,2,2,2,2,3,1,0,0,0,255,255,1,1,1,1,1,1,255,255}};

//byte test_sprite[2][100]={//печатается как угодно первый адрес - номер строки, второй адрес - номер столбца. Все перевернуто.
//                      {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
//                      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
//                      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,
//                      0,0,0,0,0,0,132,134,3,1,1,1,1,3,254,252,0,0,224,241,
//                      17,17,17,17,17,19,254,252,0,0,0,0,0,0,255,255,0,0,0,0},
//                      {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
//                      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
//                      0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,3,3,
//                      2,2,2,2,0,0,0,1,3,2,2,2,2,3,1,0,0,0,0,1,
//                      3,2,2,2,2,3,1,0,0,0,128,128,128,128,255,255,128,128,128,128}};
 
const byte progressbar_sprite[2][54]={//печатается как угодно первый адрес - номер строки, второй адрес - номер столбца. Все перевернуто.
                      {255,255,255,255,255,255,255,255,255,0,0,
                      255,255,255,255,255,255,255,255,255,0,0,
                      255,255,255,255,255,255,255,255,255,0,0,
                      127,127,127,63,63,63,31,31,31,0,0,
                      15,15,15,7,7,7,3,3,3,0},
                      {255,255,255,127,127,127,63,63,63,0,0,
                      31,31,31,15,15,15,7,7,7,0,0,
                      3,3,3,1,1,1,0,0,0,0,0,
                      0,0,0,0,0,0,0,0,0,0,0,
                      0,0,0,0,0,0,0,0,0,0}};

byte error_sprite[2][100]={//печатается как угодно первый адрес - номер строки, второй адрес - номер столбца. Все перевернуто.
                      {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                      0,0,0,0,0,0,0,0,0,0,255,255,8,8,8,8,8,8,255,255,
                      0,0,7,143,216,112,32,32,32,32,255,255,0,0,252,254,3,1,1,1,
                      1,3,254,252,0,0,255,255,192,96,48,24,12,6,255,255,0,0,255,255,
                      1,1,127,127,1,1,255,255,0,0,252,254,3,1,1,1,1,3,254,252},
                      {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                      0,0,0,0,0,0,0,0,0,0,0,1,3,2,2,2,2,3,1,0,
                      0,0,3,3,0,0,0,0,0,0,3,3,0,0,0,1,67,66,66,66,
                      67,97,63,31,0,0,3,3,0,0,0,0,0,0,3,3,0,0,3,3,
                      0,0,0,0,0,0,3,3,0,0,63,127,192,128,128,128,128,192,127,63}};
//*********************************************//
//KEYBOARD PART--------------------------------//
//*********************************************//
byte key_press=0;     // текущее значение PORTC.
byte key_hold=254;    // хранит данные, какая кнопка сейчас нажата 254 это кнопки не нажаты, дверь закрыта.
byte key_denoize=0;   // счетчик дребезга (до 32)
byte key_press2=254;  // предыдущее значение нажатых кнопок. обслуживает подавление дребезга
byte key_door=0;      // Это выделение обработки дверцы, чтобы не глючила.
byte key_lock=0;      // защелка для кнопок и команд
int counter;          // общий универсальный счетчик.
int counter1=0;       // Универсальный счетчик
int counter2=0;       // Универсальный счетчик
byte Global_mode;       // сдесь или PLAY [2] или STOP [1] или NO_DISK [0]
// byte Command_mode;      // отработчик комманд, скриптов и ошибок. избавляемся от строк. 0 - открыт лоток.
byte Current_mode;      // текущий статус, чем занимается сидюк. избавляемся от строк.
                        // 0 - String ("INIT_SERVO")
                        // 1 - String ("INIT_OK")
                        // 2 - String ("PARKING")
                        // 3 - String ("FIND_ZERO")
                        // 4 - String ("PICKUP_RDY")
                        // 5 - String ("FOCUS_WAIT")
                        // 6 - String ("STOP")
                        // 7 - String ("NO_DISK")
                        // 8 - String ("FOCUS_OK")
                        // 9 - String ("PLMUTE_WT")
                        //10 - String ("DISK_ERROR")
                        //11 - String ("PLAY_MUTE")
                        //12 - String ("SEARCH_TOC")
                        //13 - String ("PLAY_BACK")
                        //14 - String ("TOC_ERROR") 
                        //15 - String ("SKIP_TOC")
                        //16 - String ("PLAY_MID")
                        //17 - String ("PLAY_READY")
                        //18 - String ("PLAY_LOUD")
                        //19 - String ("FORWARD_RW")
                        //20 - String ("BACKWARD_R")
                        //21 - String ("PLAY_PAUSE")
                        //22 - String ("PAUSE_ON")
                        //23 - String ("PLAY_AGAIN")
                        //24 - String ("SEARCH")
                        
//*********************************************//
//KEYBOARD PART END----------------------------//
//*********************************************//
         // Command_Write(64);  //Focus start
         // Command_Write(0);   //Stop
         // Command_Write(144); //Play Mute
         // Command_Write(128); //Play Loud
         // Command_Write(32);  //FEED Forward
         // Command_Write(48);  //FEED Return
         // Command_Write(96);  //Disk Start
         // Command_Write(112); //Disk Brake
         // Command_Write(220); // FB*2 ZERO VOLUME
         // Command_Write(1);   //+1 TRACK KICK
         // Command_Write(17);  //-1 TRACK KICK
         // Command_Write(160); //FF*2 0,25 Volume
         // Command_Write(176); //FB*2 0,25 Volume
         // Command_Write(192); // FFF 0,25 Volume
         // Command_Write(208); // FFB 0,25 Volume
         // Command_Write(8);   //INITIAL SET
         // Command_Search(224,minute, second, frame);
//*********************************************//
//Q-CODE PART----------------------------------//
//*********************************************//
const byte LASER_Pin = 0;   // set pin 0 as the LASER_ON. LOW - LASER ON and HIGH is LASER OFF
const byte RW_Pin = 1;      // set pin 1 as the R/W line for write command to YM7121C
const byte WQ_Pin = 2;      // set pin 2 as the WQ line for read status from YM7121C
const byte MOSIPin=5;       // SPI PIN Configuration
const byte MISOPin=6;       // SPI PIN Configuration
const byte SCKPin=7;        // SPI PIN Configuration
const byte OPEN_Pin=8;      //Set Pin 8 as OPEN Output line Для Парасаунда не нужно.
const byte CLOSE_Pin=9;     // set pin 9 as the CLOSE output line. HIGH is for activate motor. DEFAULT is LOW
const byte REMOTE_Pin=11;   // set pin 11 as a remote sensor interrupt. HIGH as DEFAULT
const byte SMUTE_Pin=12;    // set pin 12 as a SMUTE pin. LOW at PLAY and HIGH at STOP
const byte PUIN_Pin = 13;   // set pin 13 as a PickUp IN sensor LOW is a HEAD Park complete
byte status_player=255; //сдесь хранится статус проигрывателя 11111 - 1-мотор_стоп - 1-нет_фокуса - 1-новый Q код
                        // первые три бита используются под перемотку - search
                        // 4 b 5 ,биты используются для индикации Frame Error 4 и 8 фреймов.
byte COM_ADR=0;         // второй байт данных. сдесь кодируется валидность Q-CODE.
byte TOC_A0=0;          //байт - номер первого трека
byte TOC_A1=0;          //байт - номер последнего трека.
byte TOC_READ_OK=0;     //байт - признак прочитанного TOC
byte TOC_table[104][3]; // это таблица диска. в [101]резерв, в строке [0] байты А2 - LEADOUT
                        // в столбще [3]- ничего нет резерв.
                        // номер строки - номер трека
                        // в столбце [0] - MIN
                        // в столбце [1] - SEC
                        // в столбце [2] - FRAME
                        // содержимое массивов Q_byte
                        //[1] TNO
                        //[2] X
                        //[3] MIN
                        //[4] SEC
                        //[5] FRAME 0-74
                        //[6] PAUSE
                        //[7] AMIN
                        //[8] ASEC
                        //[9] AFRAME
byte Q_byte_new[10];    // последний прочитанный массив Q в [1] находится TNO, в [9] находится последний байт AFRAME
byte Q_byte_old[10];    // предыдущий прочитанный массив Q  в [1] находится TNO, в[9] находится последний байт AFRAME
byte TOC_MIN=0;         // сдесь нет кода BCD!!!
byte TOC_SEC=0;         // это для мотания назад. сдесь находится -9 секунд относительно окончания TOC.
byte TOC_FRAME=160;     // сдесь нет кода BCD!!!
byte TOC_POINT=0;       // Это для преобразования кода BCD в номер трека.
byte CURRENT_TRACK=1;   // Это для перемотки вперед и назад.
unsigned long Calendar_disk =3600;   // Музыкальный календарь полоска на экране. это для общего количества секунд на диске.
unsigned long Calendar_temp =0;
byte Calendar_screen=13;// Музыкальный календарь полоска на экране. это для количества точек на экране 0...53
byte Calendar_mask=3;   // Музыкальный календарь полоска на экране. это для сложения со шрифтами
unsigned long Time_start=0;//millis() long это для отсчета времени.Time_start=millis();// время интервала, милисекунды
unsigned long Time_end=0;
unsigned long Time_Q_old=0; // время между Q байтами
unsigned long Time_Q_new=0; // время между Q байтами

//раздел переменных пульта ДУ
//часть REMOTE
int remote_flag = 0;          //внутренний семафор. когда нажата кнопка =5
unsigned long remote_data=0;  //тут код команды. 32 бита
int remote_count=0;           //счетчик принятых битов. от 0 до 31. Используется в конвейере
byte remote_enable=0;         //когда кнопка нажата, =1
word remote_timer_start=0;    //внутренние преобразования таймера
word remote_timer_end=0;      //внутренние преобразования таймера

//decode_results results;
// 110мс между импульсами повторения = от 6800 до 7800 единиц - от 104,2 мс - 119,5мс
// первоначальные 9мс - 550 - 610 единица при делителе 256 и тактовой 16,7МГц
// один такт - 16микросекунд при частоте 16 Мегагерц
//затем пауза 4,5 - 5мс
//затем стартовый импульс 0,6мс
// пауза для 0 - 0,4 - 0,5мс счетчик 24-40 единиц
// пауза для 1 - 1,6мс счетчик 90 - 120 единиц.
// разделитель длительностью 0,55мс = 35 - 39 единиц при делителе 256 и тактовой 16МГц
// когда повтор, то считается от длинного стартового импульса 9мс, и повторение ищет каждые 110мс, с таким-же длинным, плюс стоповый импульс.

//для кварца 16700000
//9мс от 550 до 615
//0,55мс от 33 до 40
//0,4мс от 24 до 40
//1,6мс от 90 до 120
//110мс от 5800 до 8000

//для кварца 10240000
//9мс от 340 до 380
//0,55мс от 19 до 24
//0,4мс от 15 до 24
//1,6мс от 55 до 72
//110мс от 4000 до 4800

// коды управления
// =1=        618648B7
// =2=        6186C837
// =3=        61868877
// =4=        618608F7
// =5=        6186F00F
// =6=        618618E7
// =7=        6186E817
// =8=        618628D7
// =9=        6186A857
// =0=        61866897
// DISPLAY    618650AF
// REPEAT     6186708F
// MEMORY     6186D02F
// CLEAR      61869867
// STOP       6186906F
// PLAY       618610EF
// F.F. NEXT  618600FF
// F.B. PREV  618620DF
// SEARCH >>  618630CF
// SEARCH <<  6186B04F



void setup() {

//ATMEGA32 PORT INITIALISATION
//rs_pin = 3, en_pin = 4, d0=24, d1=25, d2=26, d3=27, d4 = 28, d5 = 29, d6 = 30, d7 = 31; данные - это порт А
//DISPLAY
DDRA=255;                 //инициализация дисплея. начало.
PORTA=0;                  //инициализация дисплея.
//KEYBOARD
DDRC=0;                   //настраиваем порт клавиатуры C на вход // не надо делать это в подпрограмме.
PORTC=255;                //Включаем внутреннюю подтяжку порта клавиатуры к 1. // не надо делать это в подпрограмме. 

//SPI, COMMAND LINE, RS,E DISP
DDRB=187;                 //все выход кроме WQ и MISO
PORTB=129;                //все в ноль, кроме SCK и LASER (LASER HI - выключено)
DDRD=23;                  //выходы OPEN, CLOSE, RESET, SMUTE
                          //входы RC, PUIN, OCSW, OVERLOAD
PORTD=112;                // в единицу PUIN, OCSW, SMUTE, остальное ноль (до SMUTE было 96)

// initialize SPI:
SPI.begin();
SPI.beginTransaction ( SPISettings (500000, MSBFIRST, SPI_MODE3)); //скорость передачи оптимизирована для кварца 10,2МГц.
// Initialize SPI END****************************//

//SERVO INITIALISE
Current_mode=0;                                 //Current_mode=String("INIT_SERVO");
Global_mode=1;                                  //Для отладки логики дверцы лотка.
Clear_TOC_table();                              // CLEARING TOC TABLE
digitalWrite(CLOSE_Pin, LOW);                   // защита от позднего старта
digitalWrite(LASER_Pin, HIGH);  //STOP

//попробуем инициализацию в этом месте
Command_Init();  //INIT YM7121C 
status_player=0;

//DISPLAY INITIALISATION
//Здесь кусок целиком из lcd.begin=================//
// 50 раз - для паузы 50 мс.
for (counter=0; counter<50; counter++) {
delayMicroseconds(1000);
if ((PINB&4)==4) Command_Read(status_player);                    // это слушает состояние WQ и при необходимости читает статус сервы.
}
if (status_player==0) Command_Init();  //INIT YM7121C повторная инициализация

digitalWrite(rs_pin, LOW);
digitalWrite(en_pin, LOW);
// Send function set command sequence
data_out=0x10|0x08|0x00;                    //data_out = LCD_8BITMODE | LCD_2LINE | LCD_5x8DOTS;  //#define LCD_8BITMODE 0x10      //#define LCD_2LINE 0x08   //#define LCD_5x8DOTS 0x00
write_command(LCD_FUNCTIONSET | data_out);  //#define LCD_FUNCTIONSET 0x20
delayMicroseconds(4500);                    // wait more than 4.1ms
// second try
write_command(LCD_FUNCTIONSET | data_out);  //#define LCD_FUNCTIONSET 0x20
delayMicroseconds(150);
// third go
write_command(LCD_FUNCTIONSET | data_out); //#define LCD_FUNCTIONSET 0x20
                                           // finally, set # lines, font size, etc.
write_command(LCD_FUNCTIONSET | data_out); //#define LCD_FUNCTIONSET 0x20
                                           //_displaymode
                                           //data_out= LCD_ENTRYLEFT | LCD_ENTRYSHIFTDECREMENT; //#define LCD_ENTRYLEFT 0x02          //#define LCD_ENTRYSHIFTDECREMENT 0x00
data_out=0x02|0x00;
                                           // set the entry mode
write_command(LCD_ENTRYMODESET | data_out);//_displaymode); //#define LCD_ENTRYMODESET 0x04
                                           // set up the LCD's number of columns and rows:
write_command(0x08);                       //выключили экран
delayMicroseconds(10);                     // this command takes a long time!
write_command(0x1F);                       //переключение в графику
delayMicroseconds(10);                     // this command takes a long time!
write_command(0x01);                       //очистили от мусора ОЗУ (т.с. что clear())
delayMicroseconds(2000);                   // this command takes a long time!
write_command(0x08|0x04);                  //включили экран
delayMicroseconds(10);                     // this command takes a long time!
                                           // set up the LCD's number of columns and rows:

if (status_player==0) Command_Init();  //INIT YM7121C третья инициализация
//далее тест работ экрана заполнением
write_command(LCD_SETCGRAMADDR | 0);
for (counter=0; counter<100; counter++) {
  write_command(LCD_SETDDRAMADDR | counter);
  write_data(255);
}
write_command(LCD_SETCGRAMADDR | 1);
for (counter=0; counter<100; counter++) {
  write_command(LCD_SETDDRAMADDR | counter);
  write_data(255);
}

// пауза 200 раз - для паузы 200 мс. при заполнении экрана
for (counter=0; counter<200; counter++) {
delayMicroseconds(1000);
if ((PINB&4)==4) Command_Read(status_player);                    // это слушает состояние WQ и при необходимости читает статус сервы.
if ((PINC&192)==0) display_mode=128;     //вход в инженерный режим отображения дисплея. контроль нажатия кнопок STOP+PLAY

}

if (status_player==0) Command_Init();  //INIT YM7121C четвертая инициализация

write_command(0x01);                      //очистили от мусора ОЗУ (т.с. что clear())
delayMicroseconds(2000);                  // this command takes a long time!
//Все, закончили с экраном=======================//

// Запускаем прерывания для чтения команд с пульта дистанционного управления
//pinMode(REMOTE_Pin, INPUT);     // D3 pin 11как вход
//digitalWrite(REMOTE_Pin, HIGH); // "подтянуть" D3
attachInterrupt(1, remote_in, CHANGE);
}

//*************************************************************************//
//*************************************************************************//
//Основной код будет сдесь.
void loop() {
keyboard();   //вызов чтения кнопок.
if((display_mode&128)!=0) {print_prog();}  //печатаем изменения на экране
else {if (display_mode==0) print_prog3();    //печатаем изменения на экране
      if (display_mode==1) print_prog2();}  //очищаем экран
if((Current_mode!=18)&&(display_mode==1)) display_mode==0;  //выход из тихого режима.


//ALLTIME ASK WQ STATUS
if ((PINB&4)==4) Command_Read(status_player);                       // это читает статус сервы по получению сиглана WQ

if ((Current_mode==0)&&(status_player!=0)) Current_mode=1;          // ("INIT_OK"); // проверка инициализации сервы

if ((Global_mode!=0)&&(Current_mode==1)) Current_mode=2;             //("PARKING");

//DAC MUTE CONTROL
if ((Current_mode==18)&&((PIND&16)==1)) PORTD&=~16; //записываем в D4 SMUTE LOW. когда PLAY
if ((Current_mode!=18)&&((PIND&16)==0)) PORTD|=16;  //записываем в D4 SMUTE HIGH когда не PLAY
//DAC MUTE CONTROL END

if (Current_mode!=18) Stop_Mode_player();       // Попытка избавиться от лишних условий в основном теле цикла. Все, что не связано с PLAY и NO DISK- там.

if ((Current_mode==13)&&(TOC_READ_OK==1)&&((millis()-Time_Q_new)>3)) {Current_mode=11;  Command_Write(144); }//PLAY MUTE Разворот если TOC нормально прочиталась.
// теперь мы точно читаем вперед

// STOP после чтения TOC. Добавлена защита от бесконечного PARKING после окончания диска (это чать mode_11|mode_13).
// сюда же потом надо будет добавить TOC_READ==2. так все-же будет правильней.
if(((Current_mode==11)||(Current_mode==13))&&(TOC_READ_OK!=0)&&(Global_mode==1)&&((millis()-Time_Q_new)>3)) // сдесь мы прочитали TOC, но пользователь не нажал PLAY, значит надо остановиться и подождать.
        {Current_mode=6; Command_Write(0); digitalWrite(LASER_Pin, HIGH);}    //String ("STOP")

// это перемотка вперед на 1 трек после TOC.
if ((Current_mode==11)&&(Q_byte_new[1]==0)&&(TOC_READ_OK!=0)&&((millis()-Time_Q_new)>3)) {// пытаемся использовать команду TRACK KICK если мы все еще на треке 0
        Current_mode=15; //Current_mode=String("SKIP_TOC");
        Command_Write(192);}
// это уже 1 трек после TOC.        
if ((Current_mode==15)&&(Q_byte_new[1]!=0)&&(TOC_READ_OK==1)&&((millis()-Time_Q_new)>3)) { // пытаемся на быстрой перемотке найти 1 трек.
        Current_mode=16; ; Command_Write(144); Time_start=millis();}      //Play Mute  String("PLAY_MID") и включить задержку.

// тут SEARCH по CURRENT_TRACK, если нажимали кнопки выбора трека.
if ((Current_mode==18)||(Current_mode==19)||(Current_mode==20)) CURRENT_TRACK=(Q_byte_new[1]&15)+(10*(Q_byte_new[1]>>4)); //это для считывания текущего трека. не забываем про BCD коды.

if ((Current_mode==15)&&(TOC_READ_OK!=0)&&(Q_byte_new[1]!=0)&&(CURRENT_TRACK!=((Q_byte_new[1]&15)+(10*(Q_byte_new[1]>>4))))) {Current_mode=24; //("SEARCH");
            delay(3);
            Command_Search(224,TOC_table[CURRENT_TRACK][0],TOC_table[CURRENT_TRACK][1], TOC_table[CURRENT_TRACK][2]);}; //другой трек.
          
// Чтение статуса в процессе SEARCH через оптимальные 32 миллисекунды.
if ((Current_mode==24)&&(millis()-Time_Q_new>31)) Command_Read(status_player); // чтение статуса не дожидаясь WQ, как написано в даташите. при поиске трека. в оригинальной прошивке тут 32мс

if ((Current_mode==24)&&(millis()-Time_Q_new>100)) {
          Command_Search(224,TOC_table[CURRENT_TRACK][0],TOC_table[CURRENT_TRACK][1], TOC_table[CURRENT_TRACK][2]);} //тестовый антизависатор перемотки

if ((Current_mode==24)&&((status_player&96)==0)&&((millis()-Time_Q_new)>3)) {
              Command_Write(144); //PLAY_MUTE
              Current_mode=16;
              Time_start=millis(); }
              
//SEARCH CONTROL END
       
if ((Current_mode==16)&&((millis()-Time_start)>50)) Current_mode=17;  //String ("PLAY_READY");  //попытка победить проскальзывания.
if ((Current_mode==17)&&((millis()-Time_Q_new)>3)) {         //попытка победить проскальзывания.
        Current_mode=18;  //String("PLAY_LOUD");
        Command_Write(128);}

//LEADOUT CONTROL
if ((Q_byte_new[1]==170)&&((millis()-Time_Q_new)>3)) 
      { Current_mode=1;
      if (Global_mode==2) Global_mode=1; //if потому, что поиск глюка, когда при открытом лотке в процессе PLAY начинается инициализация диска.
      delay(3); 
      Command_Write(0); 
      digitalWrite(LASER_Pin, HIGH); 
      Q_byte_new[1]=0; 
      Q_byte_new[7]=0; 
      CURRENT_TRACK=TOC_A0;
      clear_screen();} // проверка на окончание диска по TNO и запись в Q_byte_new, чтобы не попасть в бесконечный цикл.
if (((TOC_READ_OK==1)&&(Q_byte_new[7]>=TOC_table[0][0])&&(Q_byte_new[8]>=TOC_table[0][1])&&(Q_byte_new[9]>=TOC_table[0][2]))&&(Q_byte_new[1]!=0)&&((millis()-Time_Q_new)>3)) // проверка, что текущий ATIME больше или равен A2 TOC и играет трек отличный от 0 
      { Current_mode=1;
      delay(3);
      Command_Write(0);
      if (Global_mode==2) Global_mode=1;   //if потому, что поиск глюка, когда при открытом лотке в процессе PLAY начинается инициализация диска.
      digitalWrite(LASER_Pin, HIGH);
      Q_byte_new[1]=0;
      Q_byte_new[7]=0;
      CURRENT_TRACK=TOC_A0;
      clear_screen();} //проверка на окончание диска по TOC_TABLE 
         // паркуемся, включаем стоп, гасим лазер, ставим номер трека 0, чтобы не было зацикленности.
//LEADOUT CONTROL END

//PAUSE CONTROL
if ((Current_mode==21)&&((millis()-Time_Q_new)>3))   //включаем паузу
      {Command_Search(224,Q_byte_new[7],Q_byte_new[8], Q_byte_new[9]); // отдаем команду на текущий Q-CODE
      Current_mode=22; //String("PAUSE_ON");  // включаем режим паузы
      //Command_mode=String ("NOTHING");
      } // это для того, чтобы пауза тут-же не выключилась.
if ((Current_mode==22)&&(millis()-Time_Q_new>31))  Command_Read(status_player);  // в процессе паузы чтение статуса не дожидаясь WQ, как написано в даташите. при поиске трека.   
if ((Current_mode==23)&&((millis()-Time_Q_new)>3)) // выключаем паузу.    
      {Command_Write(144); //PLAY_MUTE
       Current_mode=16; //String ("PLAY_MID"); // через промежуточный PLAY MUTE.
       //Command_mode=String ("NOTHING");
       Time_start=millis(); }
//PAUSE CONTROL END

//вычисление музыкального календаря. 53 - начало, 0 - конец диска.
if (Current_mode>=18) {
          Calendar_temp=(Q_byte_new[7]>>4)*600+(Q_byte_new[7]&15)*60;
          Calendar_temp=Calendar_temp+((Q_byte_new[8]>>4)*10)+(Q_byte_new[8]&15);
          Calendar_temp=(Calendar_temp*54)/Calendar_disk;
          Calendar_screen=53-Calendar_temp;
          }
          
          //Calendar_screen=53-(((((Q_byte_new[7]>>4)*10)+(Q_byte_new[7]&15))*60+((Q_byte_new[8]>>4)*10)+(Q_byte_new[8]&15))*54/Calendar_disk);}

}
//*******************************************************************************//
//конец основного цикла----------------------------------------------------------//
//*******************************************************************************//



void Stop_Mode_player()     //выносим все, что не относится к проигрыванию музыки
{
//тут будет вся часть без проигрывания музыки.
if ((Current_mode==2)&&((PIND&32)==32))//if (Current_mode==String ("PARKING")&&(PUIN_=='H'))                   //едем к центру
        {Command_Write(48); digitalWrite(CLOSE_Pin, HIGH); delay(2);};          //едем к центру //тут не надо менять digitalWrite

if ((Current_mode==2)&&((PIND&32)==0))                                           //if (Current_mode==String ("PARKING")&&(PUIN_=='L'))                   //тормозим у центра
        {Command_Write(0); Current_mode=3; digitalWrite(CLOSE_Pin, LOW); delay(2);}; //мы у центра //тут не надо менять digitalWrite

if ((Current_mode==3)&&((PIND&32)==0)) {Command_Write(32); delay(80);}         //if (Current_mode==String ("FIND_ZERO")&&(PUIN_=='L')) Command_Write(32); //отползаем от центра
if ((Current_mode==3)&&((PIND&32)==32)) {Command_Write(0); Current_mode=4;};   //if (Current_mode==String ("FIND_ZERO")&&(PUIN_=='H')) {Command_Write(0); Current_mode=String ("PICKUP_RDY");}; //успешно отползли. Останавливаемся.

//START FOCUS AND DISK. WORK ONLY IN DOOR CLOSE MODE
if ((Current_mode==4)&&(Global_mode==0)) Current_mode=7;             // переход на стоп для пикапа при открытой двери. Current_mode=7 = NO_DISK 
if ((Current_mode==4)&&(Global_mode!=0)) {     //if (Current_mode==String ("PICKUP_RDY")&&(TOC_READ_OK==0))       // включаем фокус. эта часть нужна, если не прочитана TOC (новый диск)
        delay(3);   //сдесь гораздо проще поставить delay, чем мудрить с Millis()
        digitalWrite(LASER_Pin, LOW);                   //LASER ON
         Command_Write(64);                             //FOCUS ON
        Time_start=millis();                            // контроль времени включения.
        Current_mode=5;}                                // Current_mode=String ("FOCUS_WAIT");}

//STOP AFTER TOC READING
//if ((Current_mode==String ("PICKUP_RDY")&&(TOC_READ_OK!=0)&&(Global_mode==String ("STOP")))) Current_mode=String ("STOP"); //особый режим для STOP        
//if ((Current_mode==4)&&(TOC_READ_OK!=0)&&(Global_mode==1)) Current_mode=6;          //особый режим для STOP

//if (Current_mode==String ("FOCUS_WAIT")&&(millis()-Time_start>5000)) {      //Нет Диска.
if ((Current_mode==5)&&(millis()-Time_start>5000)) {      //Нет Диска.
        Command_Write(0);
        digitalWrite(LASER_Pin, HIGH);        // отключаем лазер.
        Current_mode=7;};   //Current_mode=String ("NO_DISK");};  // нет диска.

if ((Current_mode==5)&&((status_player&2)==0)) Current_mode=8; //Current_mode=String ("FOCUS_OK");

//FOCUS OK ждем Q-CODE
//if ((Current_mode==String ("FOCUS_OK"))&&((millis()-Time_Q_new)>3)) { //включаем PLAY_MUTE и ждем Q-CODE задержка необходима.
if (Current_mode==8) { //включаем PLAY_MUTE и ждем Q-CODE задержка необходима.
        delay(3);
        Command_Write(144); //PLAY MUTE
        Time_start=millis();
        Current_mode=9;};     //Current_mode=String ("PLMUTE_WT");};
        
//if (Current_mode==String ("PLMUTE_WT")&&(millis()-Time_start>25000)) {
if ((Current_mode==9)&&(millis()-Time_start>9000)) {
        Current_mode=10;  //Current_mode=String ("DISK_ERROR"); //не смог за 9 секунд прочитать Q-байт.
        Command_Write(0);
        digitalWrite(LASER_Pin, HIGH);};        //выключение лазера

//if (Current_mode==String ("PLMUTE_WT")&&((status_player&2)==1)) {


if ((Current_mode==9)&&((status_player&2)==2)) {
        Current_mode=10; //Current_mode=String ("DISK_ERROR");     // потеря фокуса.
        Command_Write(0);
        digitalWrite(LASER_Pin, HIGH);};        //выключение лазера

// строку ниже надо продублировать, если мы успешно прочитали таблицу.
// if ((Current_mode==String ("PLMUTE_WT"))&&((status_player&1)==1)) { //мы приняли ПЕРВЫЙ Q-CODE! диск начал проигрываться.
if ((Current_mode==9)&&((status_player&1)==1)) { //мы приняли ПЕРВЫЙ Q-CODE! диск начал проигрываться.
         Current_mode=11; //Current_mode=String ("PLAY_MUTE");
        Time_start=millis();} // засекаем время чтения TOC.

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
// тут поиск начала 1 трека, если мы очутились не в зоне LEAD-IN
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
if ((TOC_READ_OK==0)&&(Current_mode==11)&&(Q_byte_new[1]!=0)) //запускаем поиск начала первого трека, чтобы выйти на TOC потом)TNO не рвано 0
          {Current_mode=12;   delay(3);       //Current_mode=String ("SEARCH_TOC");                       
          Command_Search(224,0,1,112);} //это начало 1 трека.
          
//SEARCH TOC CONTROL
if ((Current_mode==12)&&((status_player&96)==0)&&((millis()-Time_Q_new)>3)) {
              Command_Write(220); //PLAY_BACK*2
              Current_mode=13; //Current_mode=String ("PLAY_BACK");
              Time_start=millis();
              TOC_FRAME=8;}     // для приема 8-ми Q-CODE до разворота.
//SEARCH CONTROL END  
  
//SEARCH CONTROL
if ((Current_mode==12)&&(millis()-Time_Q_new>31)) Command_Read(status_player); // чтение статуса не дожидаясь WQ, как написано в даташите. при поиске трека. в оригинальной прошивке тут 32мс
//выносим чтение таблицы в отдельную подпрограмму.
if (TOC_READ_OK==0) TOC_read_proc();
     
}
//END OF Stop_Mode_player()

//процедура чтения таблицы TOC сюда приходим только если TOC_READ_OK==0;
void TOC_read_proc() {
//TOC READING PROCEDURE
//это внешний цикл чтения заглавия. Если условие на строке ниже выполняется, значит мы еще не прочитали TOC и получили очередной Q-CODE.
if (((Current_mode==11)||(Current_mode==13))&&((status_player&7)==1)) { //Есть новый Q-байт, не важно вперед или назад читает. И главное таблица не прочитана.
        //Ниже чтение одной строки со всеми прибабахами. // ((COM_ADR&15)==1)&& не убрано из условия. Оно есть при чтении данных с сервы
        if (((COM_ADR&15)==1)&&(Q_byte_new[1]==0)&&(Q_byte_new[6]==0)) {         //Проверяем, что Q-CODE валидный, играет трек 0 и это не пауза.
              if (Q_byte_new[2]==160) TOC_A0=(Q_byte_new[7]&15)+(10*(Q_byte_new[7]>>4)); //Номер первого трека в коде BCD
              if (Q_byte_new[2]==161) TOC_A1=(Q_byte_new[7]&15)+(10*(Q_byte_new[7]>>4)); //Номер последнего трека в коде BCD
              if (Q_byte_new[2]==162) {TOC_table[0][0]=Q_byte_new[7]; TOC_table[0][1]=Q_byte_new[8]; TOC_table[0][2]=Q_byte_new[9];}; // начало LEAD_OUT 
              TOC_POINT=(Q_byte_new[2]&15)+(10*(Q_byte_new[2]>>4));    //переводим BCD код в нормальные числа.
              if (TOC_POINT<104) {TOC_table[TOC_POINT][0]=Q_byte_new[7]; TOC_table[TOC_POINT][1]=Q_byte_new[8]; TOC_table[TOC_POINT][2]=Q_byte_new[9];}; //читаем строку оглавления.            
              }; // прочитали 1 строку. Причем любую.
             
        //Проверяем целостность таблицы оглавления. Вдруг мы уже все прочитали.
       if (((TOC_A1!=0)&&(TOC_A0!=0))&&((TOC_table[0][0]+TOC_table[0][1]+TOC_table[0][2])>0)) { //проверяем целостность таблицы А0 А1 А2 знак >= нужен для того, чтобы правильно читать диски с 1 треком.
                 TOC_READ_OK=1; // это можно убирать на время отладки.!!
                for (counter1=TOC_A0; counter1<(TOC_A1+1); counter1++) { //проверяем целостность таблицы TOC
                           if ((TOC_table[counter1][0]+TOC_table[counter1][1]+TOC_table[counter1][2])==0) {TOC_READ_OK=0; counter2=counter1;}}//проверяем целостность таблицы каждой лини       
                }; //конец проверки целостности таблицы оглавления.
        //вычисление общего количества секунд для музыкального календаря (полоска на экране)
        if (TOC_READ_OK==1) {Calendar_disk=(((TOC_table[0][0]>>4)*10)+(TOC_table[0][0]&15))*60+((TOC_table[0][1]>>4)*10)+(TOC_table[0][1]&15);}

        //Мы же все еще не прочитали оглавление. но вылетели за пределы TOC.
        //Тут, по хорошему надо отслеживать обе границы, чтобы делать ревинд назад, и не упереть головку в стенку.
        //Условие ниже - Q-CODE валидный, ( трек не 0, или пауза ), таблица еще не прочитана.

        // разворачиваем чтение назад.
       if ((Current_mode==11)&&((COM_ADR&15)==1)&&((Q_byte_new[1]!=0)||(Q_byte_new[6]==255))&&(TOC_READ_OK==0)&&((millis()-Time_Q_new)>3)) { //Мы дошли до паузы 1 трека. надо менять статус. и ехать назад. то что это "PLAY_MUTE" учтено в условии выше.
                              //заодно уточним, что Q_byte_old[6]=0 -то есть раньше паузы небыло.
          //delay(3);
          Command_Write(220); //команда чтения назад.
          Current_mode=13; //начинаем играть назад c двухкратной скоростью без звука. //это как перемотка. 
          // надо засечь 7 секунд. Последний TIME находится в Q_byte_old!!!!!!
             TOC_MIN=Q_byte_old[3];
             TOC_SEC=Q_byte_old[4];       // загружаем TOC_TIME из Q_byte_old.
          TOC_FRAME=8;          // используем не по назначению. Убавляем пока он не будет равен 0.
          // вычитаем из TOC_TIME 8 раз.
          }  

          // разворачиваем чтение вперед. Cчитаем, сколько Q_CODE _SEC мы приняли и убавляем счетчик.
         if(Current_mode==13) { //проверка на -9 секунд TOC.
              if ((TOC_SEC!=Q_byte_new[4])) { // это проверка того, что мы отъехали назад больше чем на секунду.
                TOC_MIN=Q_byte_new[3];    // обновили TOC_TIME
                TOC_SEC=Q_byte_new[4];
                TOC_FRAME=TOC_FRAME-1;};    // уменьшили на 1 секунду чтения.
                }; 
              
          // разворачиваем чтение вперед.
         if ((TOC_FRAME==0)&&(Current_mode==13)&&((millis()-Time_Q_new)>3)) {Current_mode=11; Command_Write(144); }//PLAY MUTE Разворот в прямо при чтении TOC.

        //Если мы успешно прочитали оглавление, то выходим из этого цикла, и ставим TOC_READ_OK==1 чтобы никогда сюда не попасть.
        if (TOC_READ_OK==1) {
            TOC_FRAME=160;} // это лучше в инициализацию перенести. где лоток открывается /закрывается.        
       }; //Конец обработки нового Q_байта
//TOC READING PROCEDURE END

//TOC ERROR STRING
if (((Current_mode==11)||(Current_mode==13))&&(TOC_READ_OK==0)&&((millis()-Time_start)>10000)) {
        Current_mode=14;                   //Current_mode= String("TOC_ERROR");
        Command_Write(0);
        digitalWrite(LASER_Pin, HIGH);} //выключение лазера
// отключается на время отладки чтения TOC//

// вот мы и прочитали TOC.      
}


//******************************************************//
//Подпрограммы будут сдесь.//
//для экрана

void clear_screen()         //Процедура очистки экрана
{
write_command(LCD_SETCGRAMADDR | 0);      //процесс очистки строки 0
for (counter=0; counter<100; counter++) {
write_command(LCD_SETDDRAMADDR | counter);
write_data(0);}                
write_command(LCD_SETCGRAMADDR | 1);      //процесс очистки строки 1
for (counter=0; counter<100; counter++) {
write_command(LCD_SETDDRAMADDR | counter);
write_data(0);} 
}                           //Конец процедуры очистки экрана

void print_error()          //Процедура печати ошибки
{
for (counter=0; counter<100; counter++) {
         write_command(LCD_SETDDRAMADDR | counter);
         write_command(LCD_SETCGRAMADDR | 0);      //процесс печати. начинаем со строки 0
         write_data(error_sprite[0][counter]);}                
                
for (counter=0; counter<100; counter++) {
         write_command(LCD_SETDDRAMADDR | counter);
         write_command(LCD_SETCGRAMADDR | 1);      //процесс печати. продолжаем строкой 1
         write_data(error_sprite[1][counter]);}  
}                           //Конец процедуры печати ошибки

void print_no_disk()          //Процедура печати нет диска
{
for (counter=0; counter<100; counter++) {
         write_command(LCD_SETDDRAMADDR | counter);
         write_command(LCD_SETCGRAMADDR | 0);      //процесс печати. начинаем со строки 0
         write_data(no_disk_sprite[0][counter]);}                
                
for (counter=0; counter<100; counter++) {
         write_command(LCD_SETDDRAMADDR | counter);
         write_command(LCD_SETCGRAMADDR | 1);      //процесс печати. продолжаем строкой 1
         write_data(no_disk_sprite[1][counter]);}  
}                           //Конец процедуры печати нет диска

void print_play(byte data_out2)   //процедура печати значка режима стоп-пауза-плей
{
for (counter=0; counter<10; counter++) {          //процесс печати. начинаем со строки 0
         write_command(LCD_SETDDRAMADDR | (99-counter));
         write_command(LCD_SETCGRAMADDR | 0);
         write_data(play_sprite[data_out2][counter]);}   //конец цикла for печати строки 0
         
for (counter=0; counter<10; counter++) {          //процесс печати. продолжаем строкой 1
         write_command(LCD_SETDDRAMADDR | (99-counter)); 
         write_command(LCD_SETCGRAMADDR | 1);
         write_data(play_sprite[data_out2][counter+10]);}
}                           //Конец процедуры печати значка режима стоп-пауза-плей


void print_progressbar(byte data_offset)        //печать любой палки прогресс бара. смещения 44, 32, 21, 11, 0
 {
for (counter=0; counter<10; counter++) {
         write_command(LCD_SETDDRAMADDR | (data_offset+counter));
         write_command(LCD_SETCGRAMADDR | 0);
         write_data(progressbar_sprite[0][data_offset+counter]);}                               
for (counter=0; counter<10; counter++) {
         write_command(LCD_SETDDRAMADDR | (data_offset+counter));
         write_command(LCD_SETCGRAMADDR | 1);
         write_data(progressbar_sprite[1][data_offset+counter]);}
}        //конец  печати прогрессбара

void print_digit_x1 (byte digit_x1)         //печать единиц номера трека
{                                  
for (counter=0; counter<12; counter++) {      //процесс печати. начинаем со строки 0
         write_command(LCD_SETDDRAMADDR | (57+counter));
         write_command(LCD_SETCGRAMADDR | 0);
         write_data(digit_sprite[digit_x1][counter]);
         }         //конец цикла for печати строки 0
                                        
for (counter=0; counter<12; counter++) {      //процесс печати. продолжаем строкой 1
         write_command(LCD_SETDDRAMADDR | (57+counter));
         write_command(LCD_SETCGRAMADDR | 1);                   
         write_data(digit_sprite[digit_x1][counter+12]);
         }         //конец цикла for печати строки 1
            
}        //конец  печати номера единиц трека
                         

void print_digit_x10 (byte digit_x10)         //печать десятков номера трека                                  
{                                  
for (counter=0; counter<12; counter++) {      //процесс печати. начинаем со строки 0
         write_command(LCD_SETDDRAMADDR | (73+counter));
         write_command(LCD_SETCGRAMADDR | 0);
         write_data(digit_sprite[digit_x10][counter]);
         }         //конец цикла for печати строки 0
                                        
for (counter=0; counter<12; counter++) {      //процесс печати. продолжаем строкой 1
         write_command(LCD_SETDDRAMADDR | (73+counter));
         write_command(LCD_SETCGRAMADDR | 1);                   
         write_data(digit_sprite[digit_x10][counter+12]);
         }         //конец цикла for печати строки 1   
}         //конец  печати номера десятков трека


void print_time (byte data_out2, byte data_offset, byte line_bottom)    //печать цифр времени. Смещение 43, 32 (минуты), 11, 0 (секунды)
                                                                        //line_bottom = 1 рисуем календарь, =0 ничего не рисуем.
{
for (counter=0; counter<11; counter++) {              //процесс печати. начинаем со строки 0                                    
         Calendar_mask=0;  
         if (((data_offset+counter)<=Calendar_screen)&&(line_bottom==1)) Calendar_mask=3;    //печать полоски при line_bottom==1.                                    
         write_command(LCD_SETDDRAMADDR | (data_offset+counter));
         write_command(LCD_SETCGRAMADDR | 0);
         write_data(clock_sprite[data_out2][counter]|Calendar_mask);
         }             //конец цикла for печати строки 0                                  
for (counter=0; counter<11; counter++) {              //процесс печати. продолжаем строкой 1
         write_command(LCD_SETDDRAMADDR | (data_offset+counter));
         write_command(LCD_SETCGRAMADDR | 1);
         write_data(clock_sprite[data_out2][counter+11]);
         }             //конец цикла for печати строки 1                                                                                                   
}   //конец печати цифр времени      

void print_clock_divide (byte line_bottom)            //печать разделителя. line_bottom = 1 рисуем календарь, =0 ничего не рисуем.
{
//////////////CLOCK DIVIDE//////////////                                  
for (counter=0; counter<10; counter++) {           //процесс печати. начинаем со строки 0
         Calendar_mask=0;
         if (((22+counter)<=Calendar_screen)&&(line_bottom==1)) Calendar_mask=3;    //печать полоски.
         write_command(LCD_SETDDRAMADDR | (22+counter));
         write_command(LCD_SETCGRAMADDR | 0);
         write_data(clock_divide[0][counter]|Calendar_mask);
         }                                  
for (counter=0; counter<10; counter++) {          //процесс печати. продолжаем строкой 1
         write_command(LCD_SETDDRAMADDR | (22+counter));
         write_command(LCD_SETCGRAMADDR | 1);
         write_data(clock_divide[1][counter]);
         }       //конец цикла for печати строки 1
}       //конец печати разделителя минут и секунд.

void write_data(byte data_w)  //Процедура записи данных в экран. Работет быстро
{PORTB&=~16;             // сбрасываем пин 4 EN //digitalWrite(en_pin, LOW);
 PORTB|=8;               // устанавливаем пин 3 RS  // digitalWrite(rs_pin, HIGH); //  нужно чтобы передать данные
                         //      digitalWrite(rw_pin, LOW); // это надо будте включать, когда будет работать RW
 PORTA=data_w;
 PORTB|=16;              //устанавливаем пин 4 EN // digitalWrite(en_pin, HIGH);
 asm volatile(
    "nop\n\t"
    "nop\n\t"
    "nop\n\t"
    "nop\n\t"
    "nop\n\t"
    "nop\n\t");          // задержка в 1 мкс при частоте кварца 10 Мегагерц  // delayMicroseconds(1);    // enable pulse must be >450ns
  PORTB&=~16;            // сбрасываем пин 4 EN // digitalWrite(en_pin, LOW);
  delayMicroseconds(1);  // формирует задержку в 2 микросекунды // commands need > 37us to settle в принципе, она не нужна.
}

void write_command(byte command_w)  //Процедура записи команды в экран. Работет быстро
{ PORTB&=~16;           // сбрасываем пин 4 EN 
  PORTB&=~8;            // сбрасываем пин 3 RS  //digitalWrite(rs_pin, LOW); //нужно чтобы передать команду
                        //   digitalWrite(rw_pin, LOW); // это надо будте включать, когда будет работать RW
  PORTA=command_w;   
  PORTB|=16;            //устанавливаем пин 4 EN   // digitalWrite(en_pin, HIGH);
  asm volatile(
    "nop\n\t"
    "nop\n\t"
    "nop\n\t"
    "nop\n\t"
    "nop\n\t"
    "nop\n\t");         // задержка в 1 мкс при частоте кварца 10 Мегагерц // delayMicroseconds(1);    // enable pulse must be >450ns
  PORTB&=~16;           // сбрасываем пин 4 EN // digitalWrite(en_pin, LOW);
  delayMicroseconds(1); // формирует задержку в 2 микросекунды  // commands need > 37us to settle в принципе, она не нужна.
}



// Подпрограмма отработчик клавиатуры.
// Возвращает строку команды Command_mode.
// key_hold - это текущая нажатая кнопка 0 - ни одна кнопка не нажата.
// key_press - это то, что прочитано прямо сейчас.
// key_press2 - это то, что было прочитано в прошлый раз.
// 128 кнопка PLAY
// 64  кнопка STOP
// 32  кнопка NEXT
// 16  кнопка >>
// 8   кнопка <<
// 4   кнопка PREV
// 2   кнопка EJECT
// 1   датчик двери. HI - дверь открыта.
void keyboard(){ //key_hold отражает текущую нажатую или ненажатую клавишу. Дверь лотка всегда независима от остальных кнопок.
// DDRC=0;    //настраиваем порт C на вход // не надо делать это в подпрограмме.
// PORTC=255; //Включаем внутреннюю подтяжку к 1. // не надо делать это в подпрограмме.
 key_press=PINC; // Читаем содержимое порта C

//Это от безысходности. Приходится прямо тут проверять на отркрытие двери из-за разных глюков.
//Глюки были вызваны параллельным подключением программатора, но все равно оставлю эту часть отдельно, как более помехоустойчивую.
if ((key_press&1)==1) {Global_mode=0;                  //DOOR OPEN(0)
                              Clear_TOC_table();              //сюда добавить очистку TOC и всех временных переменных.!
                              delay(3);
                              Command_Write(0);
                              digitalWrite(LASER_Pin, HIGH);  //STOP
                              digitalWrite(CLOSE_Pin, LOW);  // отключаем езду, если текущий статус был 2 (чтобы не упираться в центр)
                              Current_mode=1;
                              key_door=0;
                              }
if ((Global_mode==0)&&((key_press&1)==0)&&(key_door<65)) key_door++;  //эта часть закрывает дверь. Счетчик дребезга пришлось сделать отдельный. Общий работал криво.
if (key_door==64)  {
                  Global_mode=1;       //DOOR CLOSE(1)
                  Current_mode=1;
                  key_door=100;
                  }

if (key_press!=key_hold) { // сдесь накапливаем нажатие кнопки. Отпускание тоже накапливаем.
      key_denoize++;
      if (key_press!=key_press2) key_denoize=0; // Это дребезг!
      key_press2=key_press;}; //в любом случае запоминаем в key_press2 текущее состояние.

// тут очень удачный момент для подсоввывания кодов с пульта ДУ.
// а чтобы все было в одном месте, сюда же добавим и проверку счетчика не переполнение.
// проверку счетчика не переполнение. (более 150мс)
if (TCNT1>4800) {// это ограничение в 150мс на отпускание кнопки. Должно быть в основном коде.
              remote_flag=0; // статус-семафор сбросили
              remote_enable=0; //кнопку отпустили
              TCCR1A = 0; //инициализация
              TCCR1B = 0; //инициализация
              TCNT1=0;     //загрузка первоначального значения
              }
// подсоввывание нажатия кнопок на ДУ.
if ((remote_data==0x6186906F)&&(remote_enable==1)) {key_denoize=24; key_press=190; remote_enable=0;} //нажата кнопка STOP на ДУ.
if ((remote_data==0x618610EF)&&(remote_enable==1)) {key_denoize=24; key_press=126; remote_enable=0;} //нажата кнопка PLAY на ДУ.
if ((remote_data==0x618600FF)&&(remote_enable==1)) {key_denoize=24; key_press=246; remote_enable=0;} //нажата кнопка NEXT TRACK на ДУ.
if ((remote_data==0x618620DF)&&(remote_enable==1)) {key_denoize=24; key_press=250; remote_enable=0;} //нажата кнопка PREV TRACK на ДУ.

if ((remote_data==0x618650AF)&&(remote_enable==1)&&((display_mode&128)==0)&&(Current_mode==18)) {display_mode=(display_mode+1)&129; remote_enable=0;} //нажата кнопка DISPLAY MODE на ДУ.

if ((remote_data==0x618630CF)&&(remote_enable==1)) {key_denoize=24; key_press=222;} //нажата кнопка  >> на ДУ
if ((remote_data==0x6186B04F)&&(remote_enable==1)) {key_denoize=24; key_press=238;} //нажата кнопка  << на ДУ

if (key_denoize>16) {             // сдесь включаем кнопку
        key_hold=key_press;       // тут правильное нажатие кнопок. И сразу же отсеиваются всякие двойные нажатия.
        key_denoize=0;
      
       // DOOR OPER LINE BOTTOM
        //if ((key_hold&1)==1) {Global_mode=0;                  //DOOR OPEN(0)
        //                      Clear_TOC_table();              //сюда добавить очистку TOC и всех временных переменных.!
        //                      delay(3);
        //                      Command_Write(0);
        //                      digitalWrite(LASER_Pin, HIGH);  //STOP
        //                      Current_mode=1;
        //                      };          
       //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

                                                  
       // if (((key_hold&1)==0)&&(Global_mode==0)) {Global_mode=1; Current_mode=1;} //DOOR CLOSE(1)
        if ((key_hold&254)==254) counter2=0; //NO KEY
        if ((key_hold&254)==126) {//PLAY
                                  if ((Global_mode!=0)) Global_mode=2;
                                  if ((Global_mode!=0)&&(Current_mode==6)) Current_mode=1; // GO TO PARKING                              
                                  if ((Current_mode==18)) Current_mode=21; //String("PLAY_PAUSE"); key_lock=0;} // переключатель на паузу.
                                  if ((Current_mode==22)) Current_mode=23; //String("PLAY_AGAIN"); key_lock=0;} // переключатель с паузы на плей.        
                                  }// меняем глобальный статус на PLAY.
        if (((key_hold&254)==190)&&(TOC_READ_OK==1)) {delay(3); Command_Write(0); digitalWrite(LASER_Pin, HIGH);  //STOP
                                  key_lock=0; //это для системы отображения. Чтобы показывался и номер трека и общее время, при стопе когда надо.
                                  CURRENT_TRACK=1;          //а то он запоминал номер последнего трека.
                                  Calendar_screen=54; // Это для системы отображения.
                                  if (Global_mode>1) {Current_mode=6; Global_mode=1;};};      //Current_mode=String ("STOP");Global_mode=String("STOP");
                                                                                              //выключаем лазер, меняем статус на "стоп", меняем глобальный статус на "стоп".
        //if ((key_hold&254)==222)  //FEED Forward    // >>
        //if ((key_hold&254)==238)  //FEED Return     // <<
        if (((key_hold&254)==246)&&(Global_mode!=0)) {//NEXT
            key_lock=32; //это для системы отображения. Чтобы показывался и номер трека и общее время, при стопе когда надо.
            CURRENT_TRACK++;
            if (CURRENT_TRACK>99) CURRENT_TRACK=1;    // защита от лишнего нажимания. пони бегает по кругу.
            if ((TOC_READ_OK!=0)&&(CURRENT_TRACK>TOC_A1)) CURRENT_TRACK=TOC_A0; // пони бегает по кругу.
            if ((Current_mode==18)||(Current_mode==24)) {Current_mode=24; //Current_mode=String ("SEARCH"); =24
            delay(3);
            Command_Search(224,TOC_table[CURRENT_TRACK][0],TOC_table[CURRENT_TRACK][1], TOC_table[CURRENT_TRACK][2]);}; //следующий трек.
                    }
        if (((key_hold&254)==250)&&(Global_mode!=0)&&(TOC_READ_OK==1)) {//PREV
                        //if ((Current_mode==18)&&(CURRENT_TRACK==TOC_A0)&&(Q_byte_new[3]==0)&&(Q_byte_new[4]<5)) CURRENT_TRACK=TOC_A1+1; // пони бегает по кругу.
                        key_lock=4; //это для системы отображения. Чтобы показывался и номер трека и общее время, при стопе когда надо.
                        CURRENT_TRACK--;
                        
                        if ((Current_mode==18)&&((Q_byte_new[3]*5+Q_byte_new[4])>4)) CURRENT_TRACK++; //это перемотка на начало текущего трека.
                        if (CURRENT_TRACK<TOC_A0) CURRENT_TRACK=TOC_A1;
                        //if ((Current_mode==18)&&(CURRENT_TRACK>TOC_A0)&&(Q_byte_new[3]==0)&&(Q_byte_new[4]<5)) CURRENT_TRACK--; // проверяем что мы в самом начале трека, и только тогда убавляем.
                        if ((Current_mode==24)&&(CURRENT_TRACK<TOC_A0))  CURRENT_TRACK=TOC_A1;// Эти две строки нужны для работы во время перемотки
                        //if ((Current_mode==24)&&(CURRENT_TRACK>TOC_A0))   CURRENT_TRACK--; // Эти две строки нужны для работы во время перемотки
                        //if ((Current_mode==6)&&(CURRENT_TRACK>TOC_A0))    CURRENT_TRACK--; //Это для режима STOP
                        if ((Current_mode==6)&&(CURRENT_TRACK<TOC_A0))    CURRENT_TRACK=TOC_A1; //Это для режима STOP
                        //       if ((TOC_READ_OK==0)&&(CURRENT_TRACK>1))    CURRENT_TRACK--; //Это для случая, когда диск только вставлен и TOC не прочитан.
                        if ((Current_mode==18)||(Current_mode==24)) {Current_mode=24; //Current_mode=String ("SEARCH"); =24
                        delay(3);
                        Command_Search(224,TOC_table[CURRENT_TRACK][0],TOC_table[CURRENT_TRACK][1], TOC_table[CURRENT_TRACK][2]);}; //предыдущий трек.
                        }      
        if ((key_hold&254)==252) counter2=7; //EJECT
        };     // сдесь включаем кнопку




//if ((key_hold&254)==190) {delay(3); Command_Write(0); digitalWrite(LASER_Pin, HIGH);       //STOP COMMAND
//                                                Current_mode=6;                             //String ("STOP");
//                                                if (Global_mode==2) Global_mode=1;                              //String("STOP");
//                                                }; //выключаем лазер, меняем статус на "стоп", меняем глобальный статус на "стоп".

if (((key_hold&254)==222)&&(Current_mode==18)) {
                        delay (3);
                        Command_Write(192);
                        Current_mode=19;
                        } //String("FORWARD_RW");} // тут перемотка вперед
if (((key_hold&254)==254)&&(Current_mode==19)) {delay(3); Command_Write(128); Current_mode=18;}  //String("PLAY_LOUD");} // отключаем перемотку вперед

if (((key_hold&254)==238)&&(Current_mode==18)&&(Q_byte_new[1]!=0)) {
                        delay(3);
                        Command_Write(208);
                        Current_mode=20;
                        } //String("BACKWARD_R");} // тут перемотка назад
if ((((key_hold&254)==254)||(Q_byte_new[1]==0))&&(Current_mode==20)) {delay(3); Command_Write(128); Current_mode=18;} //String("PLAY_LOUD");} // отключаем перемотку назад 


 //включаем режим Command_mode
//if ((key_hold&1)==1) Command_mode=0;//if ((key_hold&1)==1) Command_mode=String ("NO_DISK"); 
// if (key_hold==254) Command_mode=String ("NO_KEY_PR_");
// if ((key_hold==128)&&(Command_mode!=String("NOTHING"))) Command_mode=String ("PLAY_DISK_"); //Это защелка на PLAY
// if (key_hold==64) Command_mode=String ("STOP_DISK_");
// if ((key_hold==32)&&(Command_mode!=String("NOTHING"))) Command_mode=String ("NEXT_TRACK"); //Это защелка на NEXT TRACK
// if (key_hold==16) Command_mode=String ("FORWARD_RW");
// if (key_hold==8) Command_mode=String ("BACKWARD_R");
// if ((key_hold==4)&&(Command_mode!=String("NOTHING"))) Command_mode=String ("PREVIOUS_T"); //Это защелка на PREVIOUS TRACK
// if (key_hold==2) Command_mode=String ("OPEN_CLOSE");

// тут правильное нажатие кнопок. И сразу же отсеиваются всякие двойные нажатия.

}
//Конец подпрограммы Keyboard;



// для сервы //
//Подпрограмма инициализации сервомикросхемы//
  void Command_Init(){      //INIT YM7121C
  ACC_RW_Write();
  delayMicroseconds(80);    //TIMING COPIED FROM ORIGINAL FIRMWARE.
  ACC_RW_Write();
  delayMicroseconds(80);
  Command_Write(8);}        //INITIAL SET. MUST Resieve a status after What.
  
 //Подпрограмма выдачи однобайтовых комманд на серву.
 //откорректированы задержки согласно даташита
void Command_Write(byte address) {
  
  PORTB|=2; //устанавливаем пин 2 RW //digitalWrite(RW_Pin, HIGH);     // take the RW pin high to write command:
  delayMicroseconds(2);              // минимальная пауза 1мкс 
  SPI.transfer(address);             //  send in the address and value via SPI:
  delayMicroseconds(12);             // минимальная пауза 12мкс
  PORTB&=~2; // сбрасываем пин 2 RW  //digitalWrite(RW_Pin, LOW);      // take the RW pin low to end command:
  }
// Конец подпрограммы записи команд в серву.

// Подпрограмма выдачи команды SEARCH на серву.
void Command_Search(byte address, byte S_min, byte S_sec, byte s_frame) {

  PORTB|=2; //устанавливаем пин 2 RW  //digitalWrite(RW_Pin, HIGH);       // take the RW pin high to write command:
delayMicroseconds(2);             // минимальная пауза 1мкс
SPI.transfer(address);            //  send in the address and value via SPI:
delayMicroseconds(2);             // минимальная пауза 1мкс
SPI.transfer(S_min);
delayMicroseconds(2);             // минимальная пауза 1мкс
SPI.transfer(S_sec);
delayMicroseconds(2);             // минимальная пауза 1мкс
SPI.transfer(s_frame);
delayMicroseconds(12);             // минимальная пауза 12мкс
PORTB&=~2; // сбрасываем пин 2 RW  // digitalWrite(RW_Pin, LOW);        // take the RW pin low to end command:
  }
// Конец подпрограммы выдачи команды SEARCH

//Подпрограмма читает Q-CODE с сервы.
//Читает в глобальные переменные.
byte Command_Read(byte status_read) {
 status_player=SPI.transfer(0); //Отдельно читаем статус сидюка
 delayMicroseconds(4);          //По даташиту тут должно быть не менее 0,5мкс. Я сделал 4, в оригинале стояло 50мкс.
 COM_ADR=SPI.transfer(0);       //Отдельно читаем второй байт COM_ADR
 delayMicroseconds(4);
 Time_Q_old=Time_Q_new;         // отслеживание регулярности Q
 Time_Q_new=millis();           // отслеживание регулярности Q
 if ((status_player&1>0)&&((COM_ADR&15)==1)) {          //проверяем наличие нового Q-сообщения и его валидность.
      Q_byte_old[1]=Q_byte_new[1];         //запоминаем старое TNO
      Q_byte_new[1]=SPI.transfer(0);       // читаем новое TNO
      delayMicroseconds(4);                // сдесь должно быть не менее 0,5мкс. оригинале стояло 10мкс.
      if ((display_mode!=1)||(Current_mode!=18)) {               // это проверка на DISPLAY SILENT MODE
      for (counter2=2; counter2<10; counter2++) {
            Q_byte_old[counter2]=Q_byte_new[counter2];  //запоминаем старое Q-сообщение
            Q_byte_new[counter2]=SPI.transfer(0);       // читаем новое Q-сообщения
            delayMicroseconds(4); };   }                 // сдесь должно быть не менее 0,5мкс. оригинале стояло 10мкс.
      }; 
   delayMicroseconds(8); // по новому прочнетию даташита, тут должно быть не менее 12мкс.   По факту строкой выше - 4мкс, да тут 8, плюс 2мкс накладные расходы исполнения команд. Оптимизировано Для кварца 12МГц.         

 ACC_RW_Write(); //Подтверждаем окончание чтения.
}
// Конец подпрограммы чтения Q-CODE.

void ACC_RW_Write()   //Подтверждение получения статуса. отдельная процедура нужна для инициализации и финализации чтения статусов и Q-кодов.
{
  PORTB|=2; //устанавливаем пин 2 RW // digitalWrite(RW_Pin, HIGH); // дергаем RW вверх
  delayMicroseconds(2);       // на время 1 байта передачи данных по SPI Итоговая ширина импульса будет 3мкс.
  PORTB&=~2; // сбрасываем пин 2 RW  // digitalWrite(RW_Pin, LOW);  // дергаем RW вниз.
}



// подпрограмма очистки переменных при смене диска.
void Clear_TOC_table()
{
key_lock=0;        // для борьбы с глюком. Может поможет?
display_mode=display_mode&128;    // очистка display_mode
COM_ADR=0;         // второй байт данных. сдесь кодируется валидность Q-CODE.
TOC_A0=0;          // байт - номер первого трека. попробуем поставить 0
TOC_A1=0;          // байт - номер последнего трека. . попробуем поставить 0
TOC_READ_OK=0;     // байт - признак прочитанного TOC
TOC_MIN=0;         // сдесь нет кода BCD!!!
TOC_SEC=0;         // это для мотания назад. сдесь находится -9 секунд относительно окончания TOC.
TOC_FRAME=160;     // сдесь нет кода BCD!!!
TOC_POINT=0;       // Это для преобразования кода BCD в номер трека.
CURRENT_TRACK=1;   // Это для перемотки вперед и назад.
Time_start=0;      // millis() long это для отсчета времени. Time_start=millis();// время интервала, милисекунды
Time_end=0;
Time_Q_old=0;      // время между Q байтами
Time_Q_new=0;      // время между Q байтами  
for (counter1=0; counter1<104; counter1++) {  //обнуляем таблицу
                TOC_table[counter1][0]=0;
                TOC_table[counter1][1]=0;
                TOC_table[counter1][2]=0;};
                                                // CLEAR Q_BYTE TABLE
for (counter1=0; counter1<(10); counter1++) {   //обнуляем таблицу
                Q_byte_new[counter1]=0;
                Q_byte_old[counter1]=0;};           
}
// конец подпрограммы очистки переменных при смене диска

void print_prog2()      // Подпрограмма печати темноты на экране
{if (screen[0]!=7) {    // просто стираем все на экране к херам.
  clear_screen();
  screen[0]=7;
  screen[1]=101;
  screen[2]=101;
  screen[3]=101;
  screen[4]=101;
  screen[5]=101;
  screen[6]=101;
  screen[7]=101;
  }
  
}

void print_prog3()// Подпрограмма печати на экране
//Global mode сдесь или PLAY [2] или STOP [1] или NO_DISK [0]
//screen[10]={7,0,0,0,0,0,0,0,0,0}; //содержимое текущего экрана экрана
                                //screen[0] = 0 PLAY, =1 STOP, =2 PAUSE, =3 NODISK, =4 ERROR, =5 TEST, =6 TOC READ, =7 INITIAL VALUE
                                //screen[1] = TRACK NUM
                                //screen[2] = TRACK NUM
                                //screen[3] = MIN
                                //screen[4] = MIN
                                //screen[5] = CLOCK DIVIDE =1 при проигрывании, 2 при стопе, чтобы скрыть линейку внизу.
                                //screen[6] = SEC
                                //screen[7] = SEC
                                //screen[8] = факт печати за цикл.
                                //screen[9] = calendar_screen
{        //Начало PRINTPROG3
screen[8]=2;                      //это признак, что мы можем напечатать не более двух символов за один цикл.
if ((Global_mode==0)&&(screen[0]!=3))  {  //печатаем "нет диска"
                screen[0]=3;    //заносим в таблицу то, что мы напечатали "нет диска"
                screen[8]=0;    //больше ничего печатать мы уже не будем в этот цикл.
                print_no_disk(); 
                for (counter=1; counter<8; counter++) {   //очистка таблицы screen от треков минут и секунд.
                        screen[counter]=101;}
//              screen[8]=0;    //на всякий случай еще раз, потом можно убрать.
                }   //конец печати "нет диска"
                
//значок PLAY отдельно должен быть. Это приличных размеров костыль. и его вообще-то надо убирать.
if ((Global_mode==2)&&(screen[8]!=0)&&(TOC_READ_OK==1))        { //значок PLAY отдельно должен быть.
                                  //значек PLAY                              
                        if ((screen[0]!=0)&&(Current_mode!=22)&&(Current_mode!=7)&&(Current_mode!=10)&&(Current_mode!=14)&&(screen[8]!=0))   {      //печатаем "PLAY" при этом проверяя, что не попали на режим 22 "PAUSE"                                                      
                                  data_out=1;                                  //спрайт PLAY
                                  screen[0]=0;                                 //заносим в таблицу то, что мы напечатали "PLAY"
                                  screen[8]--;                                 //уменьшаем счетчик печати.
                                  print_play(data_out);                        //печатаем значек
                                    }                                               //конец if печати PLAY
}   //значок PLAY отдельно должен быть. окончание.

if ((Global_mode==2)&&(screen[8]>0)&&(TOC_READ_OK==1))   {             //куст печати при проигрывании диска.
                                                      //сюда же добавляем условие при отключении дисплея DISPLAY OFF и его режимах. (пока нет)                       
                        if ((screen[0]!=2)&&(Current_mode==22)&&(screen[8]!=0))   { //печатаем "PAUSE" 
                                  data_out=2;                                       //спрайт PAUSE
                                  screen[0]=2;                                 //заносим в таблицу то, что мы напечатали "PAUSE"
                                  screen[8]--;                                 //уменьшаем счетчик печати.
                                  print_play(data_out);                        //печатаем значек
                                    }                                               //конец if печати PAUSE
                         //символы номера трека
                          counter1=0;                         // тут вычисляется десяток (первая цифра)
                          data_out=CURRENT_TRACK;             // тут вычисляется остаток (вторай цифра)
                          while (data_out>9) {counter1++; data_out=data_out-10;}    // сам процесс вычисления
                         if ((data_out!=screen[2])&&(screen[8]!=0))  {         //печатаем изменившийся номер трека. начинаем со второй цифры, десятки оставляем на потом.
                                  screen[2]=data_out;                          //сохраняем напечатанный номер трека
                                  screen[8]--;                                 //уменьшаем счетчик печати.
                                  print_digit_x1(data_out);
                                 
                                    }        //конец if печати номера единиц трека
                         if ((counter1!=screen[1])&&(screen[8]!=0))   {          //печатаем изменившийся номер трека. это десятки, первая цифра.
                                  screen[1]=counter1;                           //сохраняем напечатанный номер трека
                                  screen[8]--;                                  //уменьшаем счетчик печати.
                                  print_digit_x10(counter1);
                                 
                                    }//конец if печати номера десятков трека

                         // просчитываем изменения calendar_screen и вносим его в screen[9]
                         // если данные в календаре изменились, надо перепечатать все время целиком.
                         if (Calendar_screen!=screen[9])    {screen[9]=Calendar_screen; screen[3]=101; screen[4]=101; screen[5]=101; screen[6]=101; screen[7]=101;}
                                    
                         //символы минут трека. c прогресс баром.
                         if (((Q_byte_new[3]>>4)!=screen[3])&&(screen[8]!=0)&&(Q_byte_new[1]!=0))   { //печатаем изменившееся время десятков минут;
                                  screen[3]=Q_byte_new[3]>>4;                     //сохраняем напечатанное время
                                  screen[8]--;                                    //уменьшаем счетчик печати.
                                  data_out=screen[3];
                                  print_time(data_out,43,1);                      //печатаем десятки минут. 1 - это музыкальный календарь
                                    }           //конец if печати времени десятков минут;
                         if (((Q_byte_new[3]&15)!=screen[4])&&(screen[8]!=0)&&(Q_byte_new[1]!=0))    { //печатаем изменившееся время единиц минут;
                                  screen[4]=Q_byte_new[3]&15;                     //сохраняем напечатанное время
                                  screen[8]--;                                    //уменьшаем счетчик печати.
                                  data_out=screen[4];
                                  print_time(data_out,32,1);                      //печатаем единицы минут. 1 - это музыкальный календарь
                                    }          //конец if печати времени единиц минут;
                        //разделитель минут и секунд. c прогресс баром.
                        if ((screen[5]!=1)&&(screen[8]!=0)&&(Q_byte_new[1]!=0))   {         //печатаем разделитель с прогресс баром
                                  screen[5]=1;                          //сохраняем напечатанный разделитель
                                  screen[8]--;                                    //уменьшаем счетчик печати.
                                  print_clock_divide(1);                          // печатаем разделитель с прогресс баром
                                    }     //конец if печати разделителя минут и секунд.
                         //символы десятков секунд трека. c прогресс баром.
                         if (((Q_byte_new[4]>>4)!=screen[6])&&(screen[8]!=0)&&(Q_byte_new[1]!=0))    {   //печатаем изменившееся время десятков секунд
                                  screen[6]=Q_byte_new[4]>>4;                     //сохраняем напечатанное время
                                  screen[8]--;                                    //уменьшаем счетчик печати.
                                  data_out=screen[6];
                                  print_time(data_out,11,1);                      //печатаем десятки секунд. 1 - это музыкальный календарь
                                    }           //конец if печати десятков секунд
                         //символы единиц секунд трека. c прогресс баром. 
                         if (((Q_byte_new[4]&15)!=screen[7])&&(screen[8]!=0)&&(Q_byte_new[1]!=0))    {//печатаем изменившееся время единиц секунд
                                  screen[7]=Q_byte_new[4]&15;                      //сохраняем напечатанное время
                                  screen[8]--;                                    //уменьшаем счетчик печати.
                                  data_out=screen[7];
                                  print_time(data_out,0,1);                      //печатаем единицы секунд. 1 - это музыкальный календарь
                                    }             //конец if печати единиц секунд
                                        }             //конец куста печати при проигрывании диска.

         
if ((Global_mode!=0)&&(TOC_READ_OK==0)&&(Current_mode!=7)&&(Current_mode!=10)&&(Current_mode!=14))   {             //куст печати при инициализации диска. Пропускаем коды ошибок в условии
                                //сначала очистка экрана.
                                if (screen[0]==3)   {//сначала очистка экрана. тут стояло !=6, скорее всего это и был глюк отображения. Из за него иногда был пустой экран.
                                screen[0]=6;
                                clear_screen();
                                
                                for (counter=1; counter<8; counter++) {   //очистка таблицы screen от треков минут и секунд.
                                screen[counter]=101;}
                                }             // конец очистки экрана
                        // печать PLAY или STOP как полагается
                        if ((Global_mode==1)&&(screen[4]!=151))     {
                                data_out=0;
                                screen[4]=151;   //печать STOP//спрайт STOP
                                print_play(data_out);                        //печатаем значек
                        } //конец печати STOP или PLAY 
                        
                        if ((Global_mode==2)&&(screen[4]!=152))     {
                                data_out=1;
                                screen[4]=152;   //печать PLAY//спрайт PLAY                                          
                                print_play(data_out);                        //печатаем значек                       
                        }//конец печати STOP или PLAY
                         
                        // печать первой палки. режим 3 FIND ZERO
                        if ((Current_mode==3)||(Current_mode==2))    {print_progressbar(43);}        //печать первой палки
                         // печать второй палки. режим 5 FOCUS WAIT
                        if (Current_mode==5)   {print_progressbar(32);}        //печать второй палки
                         // печать третьей палки. режим 9 PLAY MUTE WAIT
                        if (Current_mode==9)   {print_progressbar(21);}        //печать третьей палки
                         // печать четвертой палки. режим 11 PLAY MUTE
                        if (Current_mode==11)  {print_progressbar(11);}        //печать четвертой палки
                         // печать пятой палки. режим 13 PLAY BACK
                        if (Current_mode==13)   {print_progressbar(0);}        //печать пятой палки
                                
}             //конец куста печати при инициализации диска.

if ((Global_mode==1)&&(Current_mode==6)&&(TOC_READ_OK==1))  {         //куст печати при стопе, общее время диска, количество треков
                                  //значек STOP                              
                        if ((screen[0]!=1)&&(screen[8]!=0))   {      //печатаем "STOP"                                                       
                                  data_out=0;                                  //спрайт STOP
                                  screen[0]=1;                                 //заносим в таблицу то, что мы напечатали "STOP"
                                  print_play(data_out);
                                  for (counter=1; counter<8; counter++) {   //очистка таблицы screen от треков минут и секунд.
                                      screen[counter]=101;} 
                                    }                                               //конец if печати STOP
                                    
                        //символы номера трека
                          counter1=0;                         // тут вычисляется десяток (первая цифра)
                          data_out=TOC_A1;                    // общее количество треков
                          if ((key_lock&36)!=0) data_out=CURRENT_TRACK;          // переходим к печати номера трека при нажатых кнопках выбора трека
                                                                                    // тут вычисляется остаток (вторай цифра)
                          while (data_out>9) {counter1++; data_out=data_out-10;}    // сам процесс вычисления
                         if ((data_out!=screen[2]))           {         //печатаем изменившийся номер трека. начинаем со второй цифры, десятки оставляем на потом.
                                  screen[2]=data_out;                          //сохраняем напечатанный номер трека
                                  print_digit_x1(data_out);       
                                    }        //конец if печати номера единиц трека
                         if ((counter1!=screen[1]))   {          //печатаем изменившийся номер трека. это десятки, первая цифра.
                                  screen[1]=counter1;                           //сохраняем напечатанный номер трека
                                  screen[8]--;                                  //уменьшаем счетчик печати.
                                  print_digit_x10(counter1);  
                                    }//конец if печати номера десятков трека
                                    
                         //символы минут всего диска
                         if (((TOC_table[0][0]>>4)!=screen[3])&&(screen[8]!=0))   { //печатаем время десятков минут;
                                  screen[3]=TOC_table[0][0]>>4;                     //сохраняем напечатанное время
                                  data_out=screen[3];
                                  print_time(data_out,43,0);                      //печатаем десятки минут. 0 - это без полоски
                                    }           //конец if печати времени десятков минут;
                         if (((TOC_table[0][0]&15)!=screen[4])&&(screen[8]!=0))    { //печатаем время единиц минут всего диска;
                                  screen[4]=TOC_table[0][0]&15;                     //сохраняем напечатанное время
                                  data_out=screen[4];
                                  print_time(data_out,32,0);                      //печатаем единиц минут. 0 - это без полоски
                                    }          //конец if печати времени единиц минут;
                        //разделитель минут и секунд. 
                        if ((screen[5]!=2)&&(screen[8]!=0))   {         //печатаем разделитель 2 здесь, чтобы нейтрализовать прогресс бар
                                  screen[5]=2;                          //сохраняем напечатанный разделитель
                                  print_clock_divide(0);                // печатаем разделитель времени без полоски.
                                    }     //конец if печати разделителя минут и секунд.
                         //символы десятков секунд всего диска.
                         if (((TOC_table[0][1]>>4)!=screen[6])&&(screen[8]!=0))    {   //печатаем изменившееся время десятков секунд
                                  screen[6]=TOC_table[0][1]>>4;                     //сохраняем напечатанное время
                                  data_out=screen[6];
                                  print_time(data_out,11,0);                      //печатаем десятков секунд. 0 - это без полоски
                                    }           //конец if печати десятков секунд
                          //символы единиц секунд всего диска.
                          if (((TOC_table[0][1]&15)!=screen[7]))    {//печатаем изменившееся время единиц секунд
                                  screen[7]=TOC_table[0][1]&15;                      //сохраняем напечатанное время
                                  data_out=screen[7];
                                  print_time(data_out,0,0);                      //печатаем единиц секунд. 0 - это без полоски
                                    }         //конец if печати единиц секунд                                    
  
}             //конец куста печати при стопе. общее время диска.

//печать ошибок (не прочитался диск, не прочитался TOC, нет фокуса от сервы)
if ((Current_mode==7)&&(screen[0]!=3))  { // нет фокуса.
          screen[0]=3;
          print_no_disk();
           for (counter=1; counter<8; counter++) {   //очистка таблицы screen от треков минут и секунд.
                  screen[counter]=101;}
                screen[8]=0;    //на всякий случай еще раз, потом можно убрать.
          }
if ((Current_mode==10)&&(screen[0]!=4)) { //не читаемый диск. нет Q-Code
          screen[0]=4;
          print_error();
          print_time(1,11,0);             //Номер ошибки 10
          print_time(0,0,0);
          }
if ((Current_mode==14)&&(screen[0]!=4)) { //не читаемый TOC. не целая таблица TOC
          screen[0]=4;
          print_error();
          print_time(1,11,0);             //Номер ошибки 14
          print_time(4,0,0);
          }
// это отработка глюков. печать CURRENT_TRACK и screen[0]
//         write_command(LCD_SETDDRAMADDR | (55));
//         write_command(LCD_SETCGRAMADDR | 1);
//         write_data(CURRENT_TRACK);

//         write_command(LCD_SETDDRAMADDR | (56));
//         write_command(LCD_SETCGRAMADDR | 1);
//         write_data(255);
         
//         write_command(LCD_SETDDRAMADDR | (56));
//         write_command(LCD_SETCGRAMADDR | 0);
//         write_data(screen[0]);

//         write_command(LCD_SETDDRAMADDR | (55));
//         write_command(LCD_SETCGRAMADDR | 0);
//         write_data(255);


// это отработка глюков. печать CURRENT_TRACK и screen[0]
 
}         //Конец PRINTPROG3
//Конец PRINTPROG3



// Подпрограмма печати служебных данных.
void print_prog() {  //Процедура печати на экране. Печатаются только изменения.
  // печать Current_mode
data_out=0;
if (Current_mode>9)  data_out=1;
if (Current_mode>19) data_out=2;
print_digit_x10(data_out);

data_out=Current_mode;
if (Current_mode>9)  data_out=Current_mode-10;
if (Current_mode>19) data_out=Current_mode-20;
print_digit_x1(data_out);

//часы
//////////////CLOCK DIVIDE//////////////
for (counter=0; counter<10; counter++) {
  write_command(LCD_SETDDRAMADDR | (22+counter));
  write_command(LCD_SETCGRAMADDR | 0);
  write_data(clock_divide[0][counter]|(TOC_READ_OK*3));
}
for (counter=0; counter<10; counter++) {
  write_command(LCD_SETDDRAMADDR | (22+counter));
  write_command(LCD_SETCGRAMADDR | 1);
  
  write_data(clock_divide[1][counter]);
}
  
//                    Clock Area Print

//символы номера трека
 data_out=CURRENT_TRACK;          // переходим к печати номера трека при нажатых кнопках выбора трека
   counter1=0;                                                                                 // тут вычисляется остаток (вторай цифра)
   while (data_out>9) {counter1++; data_out=data_out-10;}    // сам процесс вычисления
              print_time(data_out,32,0);
              print_time(counter1,43,0);
                                  


//data_out=Q_byte_new[3]>>4; //MIN;
//write_command(LCD_SETCGRAMADDR | 0);
//for (counter=0; counter<11; counter++) {
//  write_command(LCD_SETDDRAMADDR | (43+counter));
 // write_command(LCD_SETCGRAMADDR | 0);
//  write_data(clock_sprite[data_out][counter]|0);
//}
//  write_command(LCD_SETCGRAMADDR | 1);
//for (counter=0; counter<11; counter++) {
//  write_command(LCD_SETDDRAMADDR | (43+counter));
//  write_command(LCD_SETCGRAMADDR | 1);
//  write_data(clock_sprite[data_out][counter+11]);
//}


//data_out=Q_byte_new[3]&15; //MIN;

//for (counter=0; counter<12; counter++) {
 // write_command(LCD_SETDDRAMADDR | (32+counter));
 // write_command(LCD_SETCGRAMADDR | 0);
 // write_data(clock_sprite[data_out][counter]|0);
//}
//for (counter=0; counter<11; counter++) {
 // write_command(LCD_SETDDRAMADDR | (32+counter));
 // write_command(LCD_SETCGRAMADDR | 1);
 // write_data(clock_sprite[data_out][counter+11]);
//}
data_out=Q_byte_new[4]>>4; //SEC

for (counter=0; counter<11; counter++) {
  write_command(LCD_SETDDRAMADDR | (11+counter));
  write_command(LCD_SETCGRAMADDR | 0);
  write_data(clock_sprite[data_out][counter]|0);
}
for (counter=0; counter<11; counter++) {
  write_command(LCD_SETDDRAMADDR | (11+counter));
  write_command(LCD_SETCGRAMADDR | 1);
  write_data(clock_sprite[data_out][counter+11]);
}

data_out=Q_byte_new[4]&15; //SEC
for (counter=0; counter<11; counter++) {
  write_command(LCD_SETDDRAMADDR | (counter));
  write_command(LCD_SETCGRAMADDR | 0);
  write_data(clock_sprite[data_out][counter]|0);
}
for (counter=0; counter<11; counter++) {
  write_command(LCD_SETDDRAMADDR | (counter));
  write_command(LCD_SETCGRAMADDR | 1);
  write_data(clock_sprite[data_out][counter+11]);
}

if (Global_mode==0) data_out=3;
if (Global_mode==1) data_out=0;
if (Global_mode==2) data_out=1;
if (Current_mode==22) data_out=2;
for (counter=0; counter<10; counter++) {
  write_command(LCD_SETDDRAMADDR | (99-counter));
  write_command(LCD_SETCGRAMADDR | 0);
  write_data(play_sprite[data_out][counter]);
}
for (counter=0; counter<10; counter++) {
  write_command(LCD_SETDDRAMADDR | (99-counter));
  write_command(LCD_SETCGRAMADDR | 1);
  write_data(play_sprite[data_out][counter+10]);
}
}
//Конец подпрограммы print_prog;


// нечало подпрограммы отработки прерываний
void remote_in()
{
 // remote_flag расшифровка
 // 0 - ожидания сигнала с пульта
 // 1 - начало посылки в 9мс
 // 2 - получена посылка в 9мс. Ожидание первого импульса.
 // 3 - Пришел импульс. ждем данные
 // 4 - Принимаем данные 0 или 1
 // 5 - команда принята.
 
if ((remote_flag==0)&&(digitalRead(REMOTE_Pin)==LOW))  {// заголовок 9мс



  
  TCCR1A = 0; //инициализация
  TCCR1B = 0; //инициализация
  TCNT1=0;     //загрузка первоначального значения
  TCCR1B=B00000100;    //делитель 256.   Запуск таймера. 
  remote_flag=1;} 

if ((remote_flag==5)&&(digitalRead(REMOTE_Pin)==LOW)&&(TCNT1>3600))   {//продолжение нажатия кнопки. пауза 100мс.
  //TCCR1A = 0; //инициализация
  //TCCR1B = 0; //инициализация
  TCNT1=0;     //загрузка первоначального значения
  //TCCR1B=B00000100;    //делитель 256.   Запуск таймера. 
  remote_flag=5;} // оставляем статус 5.

  
if ((remote_flag==1)&&(digitalRead(REMOTE_Pin)==HIGH))  {// заголовок 9мс. закончился.
  remote_timer_start=TCNT1;   // чтение счетчика.
  remote_flag=0;  
  if ((remote_timer_start>320)&&(remote_timer_start<440)) {remote_flag=2; remote_data=0; remote_count=0;}
  }
  
if ((remote_flag==2)&&(digitalRead(REMOTE_Pin)==LOW))  {// импульс отсечной 0,55мс
  remote_timer_start=TCNT1;   // чтение счетчика.
  remote_flag=3;}

//то был заголовок, а тут начинается конвейер
if ((remote_flag==3)&&(digitalRead(REMOTE_Pin)==HIGH)) {// импульс отсечной 0,55мс окончился
    remote_timer_end=TCNT1;
    if (((remote_timer_end-remote_timer_start)>14)&&((remote_timer_end-remote_timer_start)<28)) remote_flag=4;
    remote_timer_start=remote_timer_end;
    }

if ((remote_flag==4)&&(digitalRead(REMOTE_Pin)==LOW))  {// импульс отсечной данных 0,55мс
    remote_timer_end=TCNT1;
    if (((remote_timer_end-remote_timer_start)>45)&&((remote_timer_end-remote_timer_start)<95)) remote_data=(remote_data<<1)+1;
    if (((remote_timer_end-remote_timer_start)>13)&&((remote_timer_end-remote_timer_start)<32)) remote_data=remote_data<<1;
    remote_count++;
    remote_timer_start=remote_timer_end;
    remote_flag=3;
    }

if (remote_count>31) {remote_count=0; //Досчитали до конца
                      remote_enable=1;
                      remote_flag=5;}//кнопку нажали


}
// конец подпрограммы отработки прерываний
